<template>
  <div
    class="panel flex flex-col justify-between"
    :class="computedClass"
  >
    <div class="flex items-center justify-between">
      <img
        :alt="integration.name"
        :src="integration.image"
        class="w-6 mb-4"
      />
      <div>
        <app-integration-status v-model="status" />
        <app-integration-last-synced v-model="lastSynced" />
      </div>
    </div>
    <div>
      <div class="flex mb-2">
        <span class="block font-semibold">{{ integration.name }}</span>
        <span
          v-if="integration.premium"
          class="text-2xs text-brand-500 ml-1"
        >{{
          FeatureFlag.premiumFeatureCopy()
        }}</span>
        <span
          v-if="integration.business"
          class="text-2xs text-brand-500 ml-1"
        >{{
          FeatureFlag.businessFeatureCopy()
        }}</span>
        <span
          v-if="integration.enterprise"
          class="text-2xs text-brand-500 ml-1"
        >Enterprise</span>
      </div>
      <span class="block mb-6 text-xs text-gray-500">{{
        integration.description
      }}</span>
    </div>
    <app-integration-connect :integration="integration">
      <template
        #default="{
          connect,
          connected,
          settings,
          hasSettings,
          hasIntegration,
        }"
      >
        <div class="flex items-center justify-between">
          <template v-if="integration.enabled">
            <template v-if="integration.multiple && connections.length">
              <el-button
                class="btn btn--transparent btn--md"
                @click="openSettings"
              >
                <i class="ri-settings-2-line mr-2" />Manage
              </el-button>
            </template>
            <template v-else>
              <el-button
                v-if="!connected"
                class="btn btn--secondary btn--md"
                @click="isIntegrationsEnabled ? connect() : upgradePlan()"
              >
                {{
                  (integration.premium || integration.business || integration.enterprise) && !hasIntegration
                    || !isIntegrationsEnabled
                    ? 'Upgrade Plan'
                    : 'Connect'
                }}
              </el-button>
              <el-button
                v-else
                class="btn btn-brand btn-brand--bordered btn--md"
                :loading="loadingDisconnect"
                @click="handleDisconnect"
              >
                Disconnect
              </el-button>
            </template>
          </template>
          <el-button
            v-else
            class="btn btn-brand btn-brand--bordered btn--md"
            disabled
          >
            Comming Soon
          </el-button>
          <template v-if="connected && !integration.multiple">
            <app-integration-settings :integration="integration">
              <template #default>
                <el-button
                  v-if="hasSettings"
                  class="btn btn--transparent btn--md"
                  @click="settings"
                >
                  <i class="ri-settings-2-line mr-2" />Settings
                </el-button>
              </template>
            </app-integration-settings>
          </template>
        </div>
      </template>
    </app-integration-connect>
    <app-integration-manage-drawer v-model="settingsDrawerVisible" :integration="integration" />
  </div>
</template>

<script setup>
import { useStore } from 'vuex';
import { computed, onMounted, ref } from 'vue';
import moment from 'moment';
import { useRouter } from 'vue-router';
import { FeatureFlag } from '@/utils/featureFlag';
import AppIntegrationConnect from '@/modules/integration/components/integration-connect.vue';
import { formatLastSynced, getIntegrationStatus, getTopStatus } from '@/modules/integration/integration-utils';
import AppIntegrationManageDrawer from '@/modules/integration/components/integration-manage-drawer.vue';
import AppIntegrationLastSynced from '@/modules/integration/components/integration-last-synced.vue';
import AppIntegrationStatus from '@/modules/integration/components/integration-status.vue';
import AppIntegrationSettings from '@/modules/integration/components/integration-settings.vue';

const store = useStore();
const router = useRouter();
const props = defineProps({
  integration: {
    type: Object,
    default: () => {
    },
  },
});

const computedClass = computed(() => ({
  'integration-custom': props.integration.platform === 'custom',
}));


const settingsDrawerVisible = ref(false);

const openSettings = () => {
  settingsDrawerVisible.value = true;
};

const connections = computed(() => props.integration.connections ?? []);

const status = computed(() => {
  if (!connections.value.length) {
    return getIntegrationStatus(props.integration);
  }
  const statuses = connections.value.map((c) => getIntegrationStatus(c));
  return getTopStatus(statuses);
});

const lastSynced = computed(() => {
  console.log(connections.value.length);
  if (!connections.value.length) {
    return formatLastSynced(props.integration);
  }
  const values = connections.value.map((c) => formatLastSynced(c));
  return values.reduce((acc, date) => (date.value.isAfter(acc.value) ? date : acc), {
    value: moment(0),
  });
});


const isIntegrationsEnabled = ref(false);
onMounted(async () => {
  isIntegrationsEnabled.value = FeatureFlag.isFlagEnabled(FeatureFlag.flags.integrations);
});

const upgradePlan = () => {
  router.push('/settings?activeTab=plans');
};

const loadingDisconnect = ref(false);

const handleDisconnect = async () => {
  loadingDisconnect.value = true;
  await store.dispatch('integration/doDestroy', props.integration.id);
  loadingDisconnect.value = false;
};
</script>

<script>
export default {
  name: 'AppIntegrationListItem',
};
</script>

<style lang="scss">
.integration-custom {
  background: linear-gradient(
          117.72deg,
          #fdedea 0%,
          rgba(253, 237, 234, 0) 100%
  ),
  #ffffff;
}
</style>
